from glob import glob

import pandas as pd


def lnc_filter(data):
    data = data.dropna().drop_duplicates()
    lncrans = pd.read_csv("data/LncSEA+NONCODE+GENCODE.lnc.txt")
    lncrans = set(lncrans["LncRNA"])
    print("---------------Shape: ---------------", data.shape)
    data = data[data.LncRNA.apply(lambda x: x in lncrans)]
    print("---------------Shape: ---------------", data.shape)
    return data


def expand_row(data, col, split=","):
    r = data[col].str.split(split, expand=True)
    r = r.stack().reset_index(level=1, drop=True).dropna().rename(col)
    data = data.drop([col], axis=1).join(r)
    return data


def run(data_path, detail_path):
    ## Cancer ##
    # Timer2.0
    print("------------Timer2.0------------")
    all = []
    for file in glob(data_path[0]+"/*"):
        r = pd.read_csv(file)
        r.columns = ["_","LncRNA","Set"]
        all.append(r)
    data = pd.concat(all,ignore_index=True)
    data = data[["Set", "LncRNA"]]
    data = lnc_filter(data)
    data["Sub_Class"] = "Cancer"
    data["Class"] = "Cancer_Immunology"
    data.to_csv(detail_path[0], index=False)


run(snakemake.input, snakemake.output)
