import pandas as pd


def run(input, output):
    set_tables = list(filter(lambda x: "set_" in x, input))
    final = []
    for table in set_tables:
        data = pd.read_csv(table)
        Class = data["Class"][0]
        Sub_Class = len(data["Sub_Class"].unique())
        Set = len(data["Set"].unique())
        LncRNA = ",".join(data["LncRNA"])
        Count = len(set(LncRNA.split(",")))
        final.append([Class,Sub_Class,Set,Count])
    final = pd.DataFrame(final)
    final.columns = ["Class","Sub_Class","Set","Count"]
    final.to_csv(output[0], index=False)


run(snakemake.input, snakemake.output)
