import pandas as pd


def lnc_filter(data):
    data = data.dropna().drop_duplicates()
    lncrans = pd.read_csv("data/LncSEA+NONCODE+GENCODE.lnc.txt")
    lncrans = set(lncrans["LncRNA"])
    print("---------------Shape: ---------------",data.shape)
    data = data[data.LncRNA.apply(lambda x:x in lncrans)]
    print("---------------Shape: ---------------",data.shape)
    return data

def expand_row(data,col,split=","):
    r = data[col].str.split(split,expand=True)
    r = r.stack().reset_index(level=1, drop=True).dropna().rename(col)
    data = data.drop([col],axis=1).join(r)
    return data

def run(data_path,detail_path):
    ## TCGA ##
    # lncRNASNP
    print("---------------lncRNASNP---------------")
    data = pd.read_csv(data_path[0],sep="\t")
    data = data[["Cancer_Type","Hugo_Symbol","Chr","Exon_Start","Exon_End","Ref_allele","Alt_allele","Variant_Type"]]
    data.columns = ["Set","LncRNA","D1_Chr","D2_Start","D3_End","D4_Ref","D5_Alt","D7_Mutation_type"]
    data["D6_Gene_region"] = "exonic"
    data = lnc_filter(data)
    data["D2_Start"] = data["D2_Start"].astype(int)
    data["D3_End"] = data["D3_End"].astype(int)
    data["Sub_Class"] = "TCGA"
    data["Class"] = "Mutations"
    data.to_csv(detail_path[0], index=False)

run(snakemake.input, snakemake.output)
