import csv
import json
import os
import re
import pandas as pd

human_json_output = snakemake.output[0]
class_data_json_output = snakemake.output[1]

all_tables = os.listdir("./data_output/")
detail_tables = list(filter(lambda x: "detail_" in x, all_tables))
Class_list = list(
    map(
        lambda x: re.findall(r"set_(.*?).txt", x)[0],
        filter(lambda x: "set_" in x, all_tables),
    )
)


def get_sub_class(detail_table, Class):
    groups = re.findall(r"detail_{Class}_(.*?)\.txt".format(Class=Class), detail_table)
    if groups:
        return groups[0]
    else:
        return None

def get_sub_class_list(Class):
    data = pd.read_csv(f"data_output/set_{Class}.txt")
    return list(data["Sub_Class"].unique())



def get_class(detail_table):
    for Class in Class_list:
        if Class in detail_table:
            return Class


# human.json
print("-----------------human.json")
human_json = {}
for Class in Class_list:
    for Sub_Class_file in filter(lambda x: "detail_" + Class in x, detail_tables):
        Sub_Class = get_sub_class(Sub_Class_file, Class)
        file = os.path.join("./data_output", Sub_Class_file)
        table_name = next(csv.reader(open(file)))
        table_name = list(filter(lambda x: x != "Set", table_name))
        if Sub_Class:
            info = {
                "rule": "subclass@detail_{Class}_@(^.*?$)@".format(Class=Class),
                "table_name": table_name,
                "thead_data": list(map(lambda x: {"text": x, "title": ""}, table_name)),
            }
            human_json.setdefault(Class + "_" + Sub_Class, info)
        else:
            info = {
                "rule": "@detail_{Class}@(^.*?$)@".format(Class=Class),
                "table_name": table_name,
                "thead_data": list(map(lambda x: {"text": x, "title": ""}, table_name)),
            }
            human_json.setdefault(Class, info)
human_json = json.dumps(human_json)

with open(human_json_output, "w+") as file:
    file.write(human_json)

print("-----------------class_data.json")
# class_data.json
class_data_json = {}
for Class in Class_list:
    Sub_Class_array = []
    for Sub_Class_file in filter(lambda x: "detail_" + Class in x, detail_tables):
        Sub_Class = get_sub_class(Sub_Class_file, Class)
        if Sub_Class:
            Sub_Class_array.append(
                {
                    "value": "{Class}-{Sub_Class}".format(Class=Class, Sub_Class=Sub_Class),
                    "text": "{Sub_Class}".format(Sub_Class=Sub_Class),
                }
            )
        else:
            Sub_Class_list = get_sub_class_list(Class)
            for Sub_Class in Sub_Class_list:
                Sub_Class_array.append(
                    {
                        "value": "{Class}-{Sub_Class}".format(Class=Class, Sub_Class=Sub_Class),
                        "text": "{Sub_Class}".format(Sub_Class=Sub_Class),
                    }
                )
    class_data_json.setdefault(Class, Sub_Class_array)
class_data_json = {'human': class_data_json}
class_data_json = json.dumps(class_data_json)

with open(class_data_json_output, "w+") as file:
    file.write(class_data_json)
