import os

import pandas as pd


def run(input, output):
    set_tables = list(filter(lambda x: "set_" in x, input))
    final_main = pd.DataFrame()
    for table in set_tables:
        data = pd.read_csv(table)
        data["Count"] = data["LncRNA"].apply(lambda x: len(x.split(",")))
        final_main = pd.concat(
            [final_main, data[["Set", "Class", "Sub_Class", "Count"]]],
            ignore_index=True,
        )
    final_main = final_main.sort_values(
        by=["Class", "Sub_Class", "Set", "Count"], ascending=False
    )
    final_main = final_main.reset_index(drop=True)
    final_main = final_main.reset_index()
    final_main.to_csv(output[0], index=False)


run(snakemake.input, snakemake.output)
